<?php

/**
 * novedad_prorr_termi actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage novedad_prorr_termi
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:08:44Z Kris.Wallsmith $
 */
class novedad_prorr_termiActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_NOVEDAD_PRORR_TERMI_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_NOVEDAD_PRORR_TERMI_V' =>
        array(
            'id_novedad_prorr_termi' => 'id_novedad_prorr_termi',
            'id_contrato' => 'id_contrato',
            'id_contratista' => 'id_contratista',
            'id_tipo_novedad_cont' => 'id_tipo_novedad_cont',
            'fecha' => 'fecha',
            'numero_doc' => 'numero_doc',
            'fecha_doc' => 'fecha_doc',
            'observaciones' => 'observaciones',
            'fecha_ini_old' => 'fecha_ini_old',
            'fecha_fin_old' => 'fecha_fin_old',
            'rp_anm_old' => 'rp_anm_old',
            'rp_sgr_old' => 'rp_sgr_old',
            'fecha_rp_old' => 'fecha_rp_old',
            'valor_anm_old' => 'valor_anm_old',
            'valor_sgr_old' => 'valor_sgr_old',
            'fecha_ini_new' => 'fecha_ini_new',
            'fecha_fin_new' => 'fecha_fin_new',
            'rp_anm_new' => 'rp_anm_new',
            'rp_sgr_new' => 'rp_sgr_new',
            'fecha_rp_new' => 'fecha_rp_new',
            'valor_anm_new' => 'valor_anm_new',
            'valor_sgr_new' => 'valor_sgr_new',
            'adjunto' => 'adjunto',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log',
            'num_contrato' => 'num_contrato',
            'id_anhos' => 'id_anhos',
            'fecha_contrato' => 'fecha_contrato',
            'estado_cont' => 'estado_cont',
            'num_doc' => 'num_doc',
            'razon_social' => 'razon_social',
            'correo' => 'correo',
            'descripcion_tipnovc' => 'descripcion_tipnovc',
            'num_doc_usu_log' => 'num_doc_usu_log',
            'razon_soc_usu_log' => 'razon_soc_usu_log',
            'aplica_rp_doble' => 'aplica_rp_doble',
            'fecha_rp_sgr_old' => 'fecha_rp_sgr_old',
            'fecha_rp_sgr_new' => 'fecha_rp_sgr_new'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_NOVEDAD_PRORR_TERMI_V' => array(
            'id_novedad_prorr_termi,a' => array('!=' => array(-1)),
            'id_novedad_prorr_termi,b' => array('=' => array('id_novedad_prorr_termi')),
            'id_contrato' => array('=' => array('id_contrato')),
            'id_contratista' => array('=' => array('id_contratista')),
            'id_tipo_novedad_cont' => array('=' => array('id_tipo_novedad_cont')),
            'fecha' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'aplica_rp_doble' => array('=' => array('aplica_rp_doble')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'id_anhos', 'num_contrato', 'id_novedad_prorr_termi', 'fecha'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_novedad_prorr_termi'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_novedad_prorr_termi'); //llave primaria
    protected $field_names = array('id_contrato', 'id_contratista', 'id_tipo_novedad_cont', 'fecha', 'numero_doc', 'fecha_doc', 'observaciones',
        'fecha_ini_old', 'fecha_fin_old', 'rp_anm_old', 'rp_sgr_old', 'fecha_rp_old', 'valor_anm_old', 'valor_sgr_old',
        'fecha_ini_new', 'fecha_fin_new', 'rp_anm_new', 'rp_sgr_new', 'fecha_rp_new', 'valor_anm_new', 'valor_sgr_new',
        'adjunto', 'usuario_log', 'fecha_log', 'aplica_rp_doble', 'fecha_rp_sgr_old', 'fecha_rp_sgr_new'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_NOVEDAD_PRORR_TERMI'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_novedad_prorr_termi'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        // 20230705 Validamos que el valor a adicionar RPS_CONTRATO_V corresponda al diponible por el RP
        // Aplica a novedad prorroga y adicion tipo 2
        $id_contrato = $request['id_contrato'];
        $id_tipo_novedad_cont = $request['id_tipo_novedad_cont'];
        $rp_anm_new = !empty($request['rp_anm_new']) ? $request['rp_anm_new'] : 'null';
        $rp_sgr_new = !empty($request['rp_sgr_new']) ? $request['rp_sgr_new'] : 'null';
        $valor_anm_new = $request['valor_anm_new'];
        $valor_sgr_new = $request['valor_sgr_new'];
        if($id_tipo_novedad_cont == 2) {
            // Validamos que RP exista, si exista se compara la diferencia con el saldo anterior de lo contrario se ocmpara el saldo completo
            if ($rp_anm_new != 'null') {
                // Ubicamos el valor del RP
                $sql = <<<EOD
select *
from RPS_CONTRATO_V a 
where a.RP = $rp_anm_new and a.sgr = 0 and a.vigencia > 2020
EOD;
                $result = CN_TABLE::executeSQL($sql);
                if(count($result) > 0 ) {
                    $valor_rp = $result[0]['valor'];
                } else {
                    $errors['mensaje'] = "El RP de PGN $rp_anm_new no se encuentra.";
                    $errors['servicio'] = "novedad_prorr_termi";
                }
                $sql = <<<EOD
Select * 
from 
RVC_RPS_CDPS_CONTRATO  where rp = $rp_anm_new  and id_contrato = $id_contrato and tipo_recurso = 0
EOD;
                $result = CN_TABLE::executeSQL($sql);
                if (count($result) > 0) {
                    $valor_actual = $result[0]['valor_rp'];
                    $valor_final = $valor_actual + $valor_anm_new;
                } else { 
                    $valor_final = $valor_anm_new;   
                }  
                if($valor_final != $valor_rp) {
                    $errors['mensaje'] = "El valor ingresado no concuerda con el registrado en el RP $rp_anm_new. (valor rp: $valor_rp, valor_registrado: $valor_final)";
                    $errors['servicio'] = "novedad_prorr_termi";
                }
            }
            // Validar RP SGR
            if ($rp_sgr_new != 'null') {
                // Ubicamos el valor del RP
                $sql = <<<EOD
select *
from RPS_CONTRATO_V a 
where a.RP = $rp_sgr_new and a.sgr = 1 and a.vigencia > 2020
EOD;
                $result = CN_TABLE::executeSQL($sql);
                if(count($result) > 0 ) {
                    $valor_rp = $result[0]['valor'];
                } else {
                    $errors['mensaje'] = "El RP de SGR $rp_sgr_new no se encuentra.";
                    $errors['servicio'] = "novedad_prorr_termi";
                }
                $sql = <<<EOD
Select * 
from 
RVC_RPS_CDPS_CONTRATO  where rp = $rp_sgr_new  and id_contrato = $id_contrato and tipo_recurso = 1
EOD;
                $result = CN_TABLE::executeSQL($sql);
                if (count($result) > 0) {
                    $valor_actual = $result[0]['valor_rp'];
                    $valor_final = $valor_actual + $valor_sgr_new;
                } else { 
                    $valor_final = $valor_sgr_new;   
                }  
                if($valor_final != $valor_rp) {
                    $errors['mensaje'] = "El valor ingresado no concuerda con el registrado en el RP $rp_sgr_new. (valor rp: $valor_rp, valor_registrado: $valor_final)";
                    $errors['servicio'] = "novedad_prorr_termi";
                }
            }
        }

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $request['usuario_log'] = $request['username'];
            //$request['fecha_log'] = CN_TABLE::fechaSistema();            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        $array = sfYaml::load(dirname(__FILE__) . '/../../../../api/config/app-gwt.yml');
        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        $tag_ent_sgr = '';
        if ($entidadCliente == "2") {
            $tag_ent_sgr = '.ANM.LOCAL';
        }

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_tipo_novedad_cont = $list_data_post[0]['id_tipo_novedad_cont'];
                $fecha_fin_new = $list_data_post[0]['fecha_fin_new'];
                $rp_anm_new = !empty($list_data_post[0]['rp_anm_new']) ? $list_data_post[0]['rp_anm_new'] : 'null';
                $rp_sgr_new = !empty($list_data_post[0]['rp_sgr_new']) ? $list_data_post[0]['rp_sgr_new'] : 'null';
                $valor_anm_new = $list_data_post[0]['valor_anm_new'];
                $valor_sgr_new = $list_data_post[0]['valor_sgr_new'];
                $fecha_rp_new = $list_data_post[0]['fecha_rp_new'];
                $fecha_rp_sgr_new = $list_data_post[0]['fecha_rp_sgr_new'];
                $id_novedad_prorr_termi = $list_data_post[0]['id_novedad_prorr_termi'];
                //Variables CDPs
                //prorroga y adicion modifica valor, el resto fecha unicamente
                if ($id_tipo_novedad_cont == 2) {

                    /*
                     * Crea contrato nuevo - 20181113
                     * Campos nuevos de contrato - 20211001::LAVILA
                     * Se cambia por fecha independiente SGR - 20220316::LAVILA
                     * nvl(fecha_rp_sgr,nvl(to_date('$fecha_rp_new','yyyy-mm-dd'),fecha_rp)) as fecha_rp_sgr,
                     */
                    $sql = <<<EOD
insert into rvc_contrato
(id_contrato,
id_contratista,
num_contrato,
id_anhos,
fecha_contrato,
objeto,
obligaciones,
estado,
rp_anm,
rp_sgr,
fecha_rp,
fecha_rp_sgr,
fecha_poliza,
valor_anm,
cdp_anm,
fecha_cdp_anm,
valor_sgr,
cdp_sgr,
fecha_cdp_sgr,
dependencia,
meses_plazo,
dias_plazo,
fecha_plazo,
id_supervisor,
id_apoyo_supervisor,
fecha_ini,
fecha_fin,
marca_act_estado,
numero_pago,
valor_mensualizado,
adjunto_contrato,
adjunto_poliza,
id_area,
id_tipo_contrato,
tipo_recurso,
id_co_contrato)
                            
select
null as id_contrato,
tab0.id_contratista as id_contratista,
tab0.num_contrato,
tab0.id_anhos,
tab0.fecha_contrato,
tab0.objeto,
tab0.obligaciones,
tab0.estado,
nvl($rp_anm_new,tab0.rp_anm) as rp_anm,
nvl($rp_sgr_new,tab0.rp_sgr) as rp_sgr,
nvl(to_date('$fecha_rp_new','yyyy-mm-dd'),tab0.fecha_rp) as fecha_rp,
nvl(to_date('$fecha_rp_sgr_new','yyyy-mm-dd'),tab0.fecha_rp_sgr) as fecha_rp_sgr,
tab0.fecha_poliza,
tab0.valor_anm + $valor_anm_new as valor_anm,
nvl(rppgn.cdp,tab0.cdp_anm) as CDP_ANM,
nvl(rppgn.fecha_cdp,tab0.fecha_cdp_anm) as FECHA_CDP_ANM,
valor_sgr + $valor_sgr_new as valor_sgr,
nvl(rpsgr.cdp,tab0.cdp_sgr) as CDP_SGR,
nvl(rpsgr.fecha_cdp,tab0.fecha_cdp_sgr) as FECHA_CDP_SGR,
dependencia,
meses_plazo,
dias_plazo,
fecha_plazo,
id_supervisor,
id_apoyo_supervisor,
fecha_ini,
to_date('$fecha_fin_new','yyyy-mm-dd') as fecha_fin,
marca_act_estado,
numero_pago,
valor_mensualizado,
adjunto_contrato,
adjunto_poliza,
id_area,
id_tipo_contrato,
tipo_recurso,
id_co_contrato
from rvc_contrato tab0
-- En reunion Dany Ortega y Luis Carlos se establecieron vigencias superiores a 2020 para evitar enredos con rps años anteriores
left join RPS_CONTRATO_V rppgn on rppgn.id = nvl($rp_anm_new,null) and rppgn.estado = 1 and rppgn.sgr = 0 and rppgn.vigencia >= 2020
left join RPS_CONTRATO_V rpsgr on rpsgr.id = nvl($rp_sgr_new,null) and rpsgr.estado = 1 and rpsgr.sgr = 1 and rpsgr.vigencia >= 2020
where
id_contrato = $id_contrato                      
EOD;
                    $this->conn->execute($sql);

                    //inactiva contrato anterior
                    $sql = <<<EOD
update rvc_contrato 
set estado = 0
where id_contrato = $id_contrato                      
EOD;
                    $this->conn->execute($sql);

                    //actualiza novedad_prorr_termi - 20181205
                    $sql = <<<EOD
UPDATE rvc_novedad_prorr_termi 
SET id_contrato_new = ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato) ) )
WHERE id_novedad_prorr_termi = $id_novedad_prorr_termi                    
EOD;
                    $this->conn->execute($sql);

                    $sql = <<<EOD
update rvc_contrato 
set fecha_fin = to_date('$fecha_fin_new','yyyy-mm-dd')
where id_contrato = $id_contrato                       
EOD;

                    //$this->conn->execute($sql);
                    //20200527 Dany Ortega
                    //Registrar detalles RP CDPS para el contrato creado
                    /* $sql = <<<EOD
                      select id_contrato_new
                      from rvc_novedad_prorr_termi
                      where id_novedad_prorr_termi = $id_novedad_prorr_termi
                      EOD;
                      $result = CN_TABLE::executeSQL($sql);
                      $id_contrato_new = $result[0]['id_contrato_new']; */

                    //Insertamos los RPs
                    $sql = <<<EOD

INSERT INTO RVC_RPS_CDPS_CONTRATO
(
  ID_RPS_CDPS_CONTRATO,
  ID_CONTRATO,
  NUM_CONTRATO,
  ESTADO,
  RP,
  FECHA_RP,
  CDP,
  FECHA_CDP,
  TIPO_RECURSO,
  VALOR_RP,
  PRINCIPAL
)
(
select * 
from (select null, id_contrato,num_contrato,estado,RP_ANM as RP,FECHA_RP as FECHA_RP,CDP_ANM as CDP,FECHA_CDP_ANM as FECHA_CDP,0 as tipo_recurso,valor_anm as valor,1 as principal
from rvc_contrato
union
select null, id_contrato,num_contrato,estado,RP_SGR AS RP,nvl(FECHA_RP_SGR,FECHA_RP) as FECHA_RP,CDP_SGR as CDP,FECHA_CDP_SGR as FECHA_CDP,1 as tipo_recurso,valor_sgr as valor,1 as principal
from rvc_contrato
)
where
RP is not null and
id_contrato = ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato) ))                                        
)                                  
EOD;


                    //$this->conn->execute($sql);
                    // 20220801 Se actualiza metodo para RPS
                    // Se copian los RPs anteriores
                    // Si en nuevo Rps existe entre los Rps  se actualiza el valor 
                    // Si no existe se crea una nueva linea
                    // Los valores son obtenidos desde la vista RPS_CONTRATO_V                    
                    $sql = <<<EOD
                    INSERT INTO RVC_RPS_CDPS_CONTRATO
(
  ID_RPS_CDPS_CONTRATO,
  ID_CONTRATO,
  NUM_CONTRATO,
  ESTADO,
  RP,
  FECHA_RP,
  CDP,
  FECHA_CDP,
  TIPO_RECURSO,
  VALOR_RP,
  PRINCIPAL
)
    select 
        null,
        ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato) )) as id_contrato,
        tab0.num_contrato as num_contrato,
        tab0.estado,
        tab0.rp,
        tab0.fecha_rp,
        tab0.cdp,
        tab0.fecha_cdp,
        tab0.tipo_recurso,
        tab0.valor_rp,
        tab0.principal
    from RVC_RPS_CDPS_CONTRATO tab0
    where tab0.id_contrato = $id_contrato
EOD;
                    $this->conn->execute($sql);

                    //Ubicamos si el RP PGN ya existe si no se agrega el registro
                    if ($rp_anm_new != 'null') {
                        $sql = <<<EOD
Select * 
from 
RVC_RPS_CDPS_CONTRATO  where rp = $rp_anm_new  and id_contrato = $id_contrato and tipo_recurso = 0
EOD;
                        $result = CN_TABLE::executeSQL($sql);
                        if (count($result) > 0) {
                            $sql = <<<EOD
UPDATE RVC_RPS_CDPS_CONTRATO set valor_rp = valor_rp + $valor_anm_new
where rp = $rp_anm_new  and id_contrato =  ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato))) and tipo_recurso = 0
EOD;
                            $this->conn->execute($sql);
                        } else {
                            $sql = <<<EOD
                            INSERT INTO RVC_RPS_CDPS_CONTRATO
                                (
                                  ID_RPS_CDPS_CONTRATO,
                                  ID_CONTRATO,
                                  NUM_CONTRATO,
                                  ESTADO,
                                  RP,
                                  FECHA_RP,
                                  CDP,
                                  FECHA_CDP,
                                  TIPO_RECURSO,
                                  VALOR_RP,
                                  PRINCIPAL
                                )
                                select 
                                    null,
                                    ( select max(id_contrato) from rvc_contrato 
        where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
            where cont.id_contrato = $id_contrato) )) as id_contrato,
                                    (select num_contrato from rvc_contrato where id_contrato = $id_contrato),
                                    a.estado,
                                    a.rp,
                                    a.fecha,
                                    a.cdp,
                                    a.fecha_cdp,
                                    0 as tipo_recurso,
                                    $valor_anm_new,
                                    1 as principal
                                from RPS_CONTRATO_V a 
                                where a.RP = $rp_anm_new and a.sgr = 0 and a.vigencia > 2020
EOD;
                            $this->conn->execute($sql);
                        }
                        // Confirmamos que el RP PGN esta asociado en contratos si no hacemos la asociacion
                        $sql = <<<EOD
select * 
from co_legaliza_contrato
where id_rp = $rp_anm_new 
    and rp_sgr = 0 
    and id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                        $result = CN_TABLE::executeSQL($sql);
                        if (count($result) == 0) { // Sin existe realizamos asociasion
                            // Validamos que el proyecto no exista
                            // Ubicamos proyecto asociados al RP y consultamos cada uno para saber si existen
                            $sql = <<<EOD
select id_cpo from pr_rp_compromiso
        where id_rp = $rp_anm_new and vigencia >= 2020 group by id_rp,id_cpo                                    
EOD;
                            $result = CN_TABLE::executeSQL($sql);
                            foreach ($result as $rec) {
                                $id_cpo = $rec['id_cpo'];
                                $sql = <<<EOD
select * 
from co_proyecto_ep
where ID_CPO = $id_cpo
and id_estudios_previos = (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)))
and SGR = 0
EOD;
                                $result = CN_TABLE::executeSQL($sql);
                                if (count($result) == 0) {
                                    // Agregamos registro en tabla CO_PROYECTo_EP
                                    $sql = <<<EOD
INSERT INTO CO_PROYECTO_EP(ID_CPO,ID_ESTUDIOS_PREVIOS,VALOR,SGR)
SELECT ID_CPO,
    (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))) as ID_ESTUDIOS_PREVIOS,
    VALOR,
    0 as SGR
    from (select id_rp,id_cpo, sum(valor) as valor from pr_rp_compromiso 
        where id_rp = $rp_anm_new group by id_rp,id_cpo)
EOD;
                                    $this->conn->execute($sql);
                                }
                            }
                            // Agregamos Registro RP en CO_LEGALIZA_CONTRATO
                            $sql = <<<EOD
INSERT INTO CO_LEGALIZA_CONTRATO(ID_CONTRATO,ID_RP,FECHA_APRUEBA_POLIZA,FECHA_INICIO,FECHA_TERMINACION,RP_SGR,VIGENCIA_RP)
select 
    (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato) as ID_CONTRATO,
    $rp_anm_new,    
    leg.FECHA_APRUEBA_POLIZA,leg.FECHA_INICIO,leg.FECHA_TERMINACION,
    0 as SGR,
    rp.vigencia
FROM (select max(FECHA_APRUEBA_POLIZA) as FECHA_APRUEBA_POLIZA,
    max(FECHA_INICIO) as FECHA_INICIO,max(FECHA_TERMINACION) as FECHA_TERMINACION 
        from CO_LEGALIZA_CONTRATO where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))leg
    left join RPS_CONTRATO_V rp on rp.id = $rp_anm_new and rp.estado = 1 and rp.sgr = 0 and rp.vigencia >= 2020
                              
EOD;
                            $this->conn->execute($sql);
                        }
                    }

                    //Ubicamos si el RP SGR ya existe si no se agrega el registro
                    if ($rp_sgr_new != 'null') {
                        $sql = <<<EOD
Select * 
from 
    RVC_RPS_CDPS_CONTRATO  where rp = $rp_sgr_new  and id_contrato = $id_contrato and tipo_recurso = 1
EOD;
                        $result = CN_TABLE::executeSQL($sql);
                        if (count($result) > 0) {
                            $sql = <<<EOD
                            UPDATE RVC_RPS_CDPS_CONTRATO set valor_rp = (select valor 
                                from RPS_CONTRATO_V a 
                                where a.RP = $rp_sgr_new and a.sgr = 1 and a.vigencia > 2020)
                            where rp = $rp_sgr_new  and id_contrato =  ( select max(id_contrato) from rvc_contrato 
        where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
            where cont.id_contrato = $id_contrato) )) and tipo_recurso = 1
EOD;
                            $sql = <<<EOD
                            UPDATE RVC_RPS_CDPS_CONTRATO set valor_rp = valor_rp + $valor_sgr_new
                            where rp = $rp_sgr_new  and id_contrato =  ( select max(id_contrato) from rvc_contrato 
        where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
            where cont.id_contrato = $id_contrato) )) and tipo_recurso = 1
EOD;
                            $this->conn->execute($sql);
                        } else {
                            $sql = <<<EOD
                            INSERT INTO RVC_RPS_CDPS_CONTRATO
                                (
                                  ID_RPS_CDPS_CONTRATO,
                                  ID_CONTRATO,
                                  NUM_CONTRATO,
                                  ESTADO,
                                  RP,
                                  FECHA_RP,
                                  CDP,
                                  FECHA_CDP,
                                  TIPO_RECURSO,
                                  VALOR_RP,
                                  PRINCIPAL
                                )
                                select 
                                    null,
                                    ( select max(id_contrato) from rvc_contrato 
        where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
            where cont.id_contrato = $id_contrato) )) as id_contrato,
                                    (select num_contrato from rvc_contrato where id_contrato = $id_contrato),
                                    a.estado,
                                    a.rp,
                                    a.fecha,
                                    a.cdp,
                                    a.fecha_cdp,
                                    1 as tipo_recurso,
                                    $valor_sgr_new,
                                    1 as principal
                                from RPS_CONTRATO_V a 
                                where a.RP = $rp_sgr_new and a.sgr = 1 and a.vigencia > 2020
EOD;
                            $this->conn->execute($sql);
                        }
                        // Confirmamos que el RP SGR esta asociado en contratos si no hacemos la asociacion
                        $sql = <<<EOD
select * 
from co_legaliza_contrato
where id_rp = $rp_sgr_new 
    and rp_sgr = 1 
    and id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                        $result = CN_TABLE::executeSQL($sql);
                        if (count($result) == 0) { // Sin existe realizamos asociasion
                            // Validamos que el proyecto no exista
                            // Ubicamos proyecto asociados al RP y consultamos cada uno para saber si existen
                            $sql = <<<EOD
select id_cpo from pr_rp_compromiso@PNG_SGR$tag_ent_sgr
        where id_rp = $rp_sgr_new and vigencia >= 2020 group by id_rp,id_cpo                                   
EOD;
                            $result = CN_TABLE::executeSQL($sql);
                            foreach ($result as $rec) {
                                $id_cpo = $rec['id_cpo'];
                                $sql = <<<EOD
select * 
from co_proyecto_ep
where ID_CPO = $id_cpo
and id_estudios_previos = (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)))
and SGR = 1
EOD;
                                $result = CN_TABLE::executeSQL($sql);
                                if (count($result) == 0) {
                                    // Agregamos registro en tabla CO_PROYECTo_EP
                                    $sql = <<<EOD
INSERT INTO CO_PROYECTO_EP(ID_CPO,ID_ESTUDIOS_PREVIOS,VALOR,SGR)
SELECT ID_CPO,
    (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))) as ID_ESTUDIOS_PREVIOS,
    VALOR,
    1 as SGR
    from (select id_rp,id_cpo, sum(valor) as valor from pr_rp_compromiso@PNG_SGR$tag_ent_sgr
        where id_rp = $rp_sgr_new and vigencia >= 2020 group by id_rp,id_cpo)
EOD;
                                    $this->conn->execute($sql);
                                }
                            }
                            /**
                             * Agregamos Registro RP en CO_LEGALIZA_CONTRATO
                             * Se deja '1 as SGR,' ya que es el if de SGR - 20230131::LAVILA
                             */
                            $sql = <<<EOD
INSERT INTO CO_LEGALIZA_CONTRATO(ID_CONTRATO,ID_RP,FECHA_APRUEBA_POLIZA,FECHA_INICIO,FECHA_TERMINACION,RP_SGR,VIGENCIA_RP)
select 
    (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato) as ID_CONTRATO,
    $rp_sgr_new,    
    leg.FECHA_APRUEBA_POLIZA,leg.FECHA_INICIO,leg.FECHA_TERMINACION,
    1 as SGR,
    rp.vigencia
FROM (select max(FECHA_APRUEBA_POLIZA) as FECHA_APRUEBA_POLIZA,
    max(FECHA_INICIO) as FECHA_INICIO,max(FECHA_TERMINACION) as FECHA_TERMINACION 
        from CO_LEGALIZA_CONTRATO where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))leg
    left join RPS_CONTRATO_V rp on rp.id = $rp_sgr_new and rp.estado = 1 and rp.sgr = 1 and rp.vigencia >= 2020
                              
EOD;
                            $this->conn->execute($sql);
                        }
                    }

                    // Actualizamos el VAlor del contrato nuevo
                    $sql = <<<EOD
UPDATE RVC_CONTRATO set (valor_anm,valor_sgr) =         
    (select 
        sum(case when tipo_recurso = 0 then valor_rp else 0 end) as valor_anm,
        sum(case when tipo_recurso = 1 then valor_rp else 0 end) as valor_sgr
    from
        RVC_RPS_CDPS_CONTRATO 
    where id_contrato = (select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
    where cont.id_contrato = $id_contrato))))
WHERE id_contrato = (select max(id_contrato) from rvc_contrato 
where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
    where cont.id_contrato = $id_contrato)))
EOD;
                    $this->conn->execute($sql);


                    // Actualizar numero de pagos en la tabla co_contrato
                    $sql = <<<EOD
UPDATE CO_CONTRATO 
set  numero_pago = (
    select 
 case when cesion.pagos is null then prorroga.pagos else cesion.pagos end as pagos
from
    (select sum(tab0.pagos) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, max(tab0.fecha_ini) as fecha_ini,min(tab0.fecha_fin) as fecha_fin, 
        ceil(MONTHS_BETWEEN(last_day(min(tab0.fecha_fin)), to_date(to_char(max(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, tab0.fecha_ini,tab1.fecha_cesion as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato
        UNION
        select tab0.id_contrato, tab0.num_contrato, tab1.fecha_cesion as fecha_ini ,tab0.fecha_fin as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato_new)tab0
        where tab0.num_contrato = (select num_contrato from rvc_contrato where id_contrato =$id_contrato)
        group by tab0.id_contrato, tab0.num_contrato)tab0)cesion
left join (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato ))
)prorroga on 1=1) 
where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                    $this->conn->execute($sql);

                    // Actualizar numero de pagos en la tabla rvc_contrato
                    $sql = <<<EOD
UPDATE RVC_CONTRATO 
set  numero_pago = (
    select 
 case when cesion.pagos is null then prorroga.pagos else cesion.pagos end as pagos
from
    (select sum(tab0.pagos) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, max(tab0.fecha_ini) as fecha_ini,min(tab0.fecha_fin) as fecha_fin, 
        ceil(MONTHS_BETWEEN(last_day(min(tab0.fecha_fin)), to_date(to_char(max(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, tab0.fecha_ini,tab1.fecha_cesion as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato
        UNION
        select tab0.id_contrato, tab0.num_contrato, tab1.fecha_cesion as fecha_ini ,tab0.fecha_fin as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato_new)tab0
        where tab0.num_contrato = (select num_contrato from rvc_contrato where id_contrato =$id_contrato)
        group by tab0.id_contrato, tab0.num_contrato)tab0)cesion
left join (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato ))
)prorroga on 1=1) 
where id_contrato =  (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                    $this->conn->execute($sql);

                    // ACtualizar Meses y dias plazo para el contrato nuevo
                    // Obtenemos fecha inicio y fecha fin contrato nuevo
                    $sql = <<<EOD
Select to_char(fecha_ini,'YYYY-MM-DD') as fecha_inicio, to_char(fecha_fin,'YYYY-MM-DD') as fecha_fin
FRom RVC_CONTRATO
where id_contrato = (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                    $result = CN_TABLE::executeSQL($sql);
                    $fecha_ini = $result[0]['fecha_inicio'];
                    $fecha_fin = $result[0]['fecha_fin'];
                    $fecha_ini = new DateTime($fecha_ini);
                    $fecha_fin = new DateTime($fecha_fin);
                    $diferencia = $fecha_ini->diff($fecha_fin);
                    //execute sql
                    $record = array();
                    $anhos = $diferencia->y;
                    $meses = $diferencia->m + ($anhos * 12);
                    $dias = $diferencia->d + 1;

                    // Actualizamos el registro
                    $sql = <<<EOD
UPDATE rvc_contrato set meses_plazo = $meses, dias_plazo = $dias
where id_contrato = (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                    $this->conn->execute($sql);

                    //Incidente #35171, se crea registro copia de la tabla rvc_rps_saldo_no_ejecutado por bienio - 20230330::LAVILA
                    $sql = <<<EOD
insert into rvc_rps_saldo_no_ejecutado (
ID,
ID_CONTRATO,
ESTADO,
RP,
VIGENCIA,
TIPO_RECURSO,
VALOR,
ID_CPO
)

select
null as ID,
( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato) ) ) as ID_CONTRATO,
ESTADO,
RP,
VIGENCIA,
TIPO_RECURSO,
VALOR,
ID_CPO
from rvc_rps_saldo_no_ejecutado

where
id_contrato = $id_contrato 
EOD;
                    $this->conn->execute($sql);
                } else {

                    $sql = <<<EOD
update rvc_contrato 
set fecha_fin = to_date('$fecha_fin_new','yyyy-mm-dd')
where id_contrato = $id_contrato                       
EOD;

                    $this->conn->execute($sql);

                    // Actualizar numero de pagos en la tabla co_contrato
                    $sql = <<<EOD
UPDATE CO_CONTRATO 
set  numero_pago = (
    select 
 case when cesion.pagos is null then prorroga.pagos else cesion.pagos end as pagos
from
    (select sum(tab0.pagos) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, max(tab0.fecha_ini) as fecha_ini,min(tab0.fecha_fin) as fecha_fin, 
        ceil(MONTHS_BETWEEN(last_day(min(tab0.fecha_fin)), to_date(to_char(max(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, tab0.fecha_ini,tab1.fecha_cesion as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato
        UNION
        select tab0.id_contrato, tab0.num_contrato, tab1.fecha_cesion as fecha_ini ,tab0.fecha_fin as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato_new)tab0
        where tab0.num_contrato = (select num_contrato from rvc_contrato where id_contrato =$id_contrato)
        group by tab0.id_contrato, tab0.num_contrato)tab0)cesion
left join (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato ))
)prorroga on 1=1) 
where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                    $this->conn->execute($sql);
                    // Actualizar numero de pagos en la tabla rvc_contrato
                    $sql = <<<EOD
UPDATE RVC_CONTRATO 
set  numero_pago = (
    select 
 case when cesion.pagos is null then prorroga.pagos else cesion.pagos end as pagos
from
    (select sum(tab0.pagos) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, max(tab0.fecha_ini) as fecha_ini,min(tab0.fecha_fin) as fecha_fin, 
        ceil(MONTHS_BETWEEN(last_day(min(tab0.fecha_fin)), to_date(to_char(max(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, tab0.fecha_ini,tab1.fecha_cesion as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato
        UNION
        select tab0.id_contrato, tab0.num_contrato, tab1.fecha_cesion as fecha_ini ,tab0.fecha_fin as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato_new)tab0
        where tab0.num_contrato = (select num_contrato from rvc_contrato where id_contrato =$id_contrato)
        group by tab0.id_contrato, tab0.num_contrato)tab0)cesion
left join (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato ))
)prorroga on 1=1) 
where id_contrato =  (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                    $this->conn->execute($sql);

                    // ACtualizar Meses y dias plazo para el contrato nuevo
                    // Obtenemos fecha inicio y fecha fin contrato nuevo
                    $sql = <<<EOD
Select to_char(fecha_ini,'YYYY-MM-DD') as fecha_inicio, to_char(fecha_fin,'YYYY-MM-DD') as fecha_fin
FRom RVC_CONTRATO
where id_contrato = (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                    $result = CN_TABLE::executeSQL($sql);
                    $fecha_ini = $result[0]['fecha_inicio'];
                    $fecha_fin = $result[0]['fecha_fin'];
                    $fecha_ini = new DateTime($fecha_ini);
                    $fecha_fin = new DateTime($fecha_fin);
                    $diferencia = $fecha_ini->diff($fecha_fin);
                    //execute sql
                    $record = array();
                    $anhos = $diferencia->y;
                    $meses = $diferencia->m + ($anhos * 12);
                    $dias = $diferencia->d + 1;
                    // Actualizamos el registro
                    $sql = <<<EOD
UPDATE rvc_contrato set meses_plazo = $meses, dias_plazo = $dias
where id_contrato = (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        //actualiza novedad_prorr_termi - 20181213
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_tipo_novedad_cont = $list_data_post[0]['id_tipo_novedad_cont'];
                $fecha_fin_new = $request['fecha_fin_new'];
                $rp_anm_new = $list_data_post[0]['rp_anm_new'];
                $rp_sgr_new = $list_data_post[0]['rp_sgr_new'];
                $valor_anm_new = $list_data_post[0]['valor_anm_new'];
                $valor_sgr_new = $list_data_post[0]['valor_sgr_new'];
                $fecha_rp_new = $request['fecha_rp_new'];
                $fecha_rp_sgr_new = $request['fecha_rp_sgr_new'];
                $id_novedad_prorr_termi = $list_data_post[0]['id_novedad_prorr_termi'];
                $valor_anm_old = $list_data_post[0]['valor_anm_old'];
                $valor_sgr_old = $list_data_post[0]['valor_sgr_old'];

                //prorroga y adicion modifica valor, el resto fecha unicamente
                if ($id_tipo_novedad_cont == 2) {

                    $sql = <<<EOD
update rvc_contrato 
set fecha_fin = nvl(to_date('$fecha_fin_new','yyyy-mm-dd'), fecha_fin) ,
    rp_anm = '$rp_anm_new',
    rp_sgr = '$rp_sgr_new',
    fecha_rp = nvl(to_date('$fecha_rp_new','yyyy-mm-dd'),fecha_rp),
    fecha_rp_sgr = nvl(to_date('$fecha_rp_sgr_new','yyyy-mm-dd'),fecha_rp_sgr),
    valor_anm = $valor_anm_old + $valor_anm_new,
    valor_sgr = $valor_sgr_old + $valor_sgr_new  
where id_contrato in (SELECT ID_CONTRATO_NEW 
    FROM rvc_novedad_prorr_termi where id_tipo_novedad_cont = 2 and id_contrato = $id_contrato)                
EOD;
                    $this->conn->execute($sql);

                    $sql = <<<EOD
update rvc_contrato 
set fecha_fin = to_date('$fecha_fin_new','yyyy-mm-dd')
where id_contrato = $id_contrato                       
EOD;

                    $this->conn->execute($sql);
                    // Actualizar numero de pagos en la tabla co_contrato
                    $sql = <<<EOD
UPDATE CO_CONTRATO 
set  numero_pago = (select ceil(MONTHS_BETWEEN(min(tab0.fecha_fin),max(tab0.fecha_ini))) as pagos
    from rvc_contrato tab0
    where tab0.id_contrato = $id_contrato) 
where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                    $this->conn->execute($sql);
                } else {

                    $sql = <<<EOD
update rvc_contrato 
set fecha_fin = to_date('$fecha_fin_new','yyyy-mm-dd')
where id_contrato = $id_contrato                       
EOD;

                    $this->conn->execute($sql);
                    // Actualizar numero de pagos en la tabla co_contrato
                    $sql = <<<EOD
UPDATE CO_CONTRATO 
set  numero_pago = (select ceil(MONTHS_BETWEEN(min(tab0.fecha_fin),max(tab0.fecha_ini))) as pagos
    from rvc_contrato tab0
    where tab0.id_contrato = $id_contrato) 
where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                    $this->conn->execute($sql);
                }

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
